<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.application.mgt.ui.ApplicationAdminClient" %>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.application.mgt.ui.types.carbon.ApplicationMetadata" %>
<%@ page import="org.wso2.carbon.application.mgt.ui.types.carbon.ServiceGroupMetadata" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<!-- This page is included to display messages which are set to request scope or session scope -->
<jsp:include page="../dialog/display_messages.jsp"/>
<jsp:include page="../dialog/dialog_header.jsp"/>

<%
    String appName = request.getParameter("appName");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config.getServletContext()
            .getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    String BUNDLE = "org.wso2.carbon.application.mgt.ui.i18n.Resources";
    ResourceBundle bundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());

    ApplicationMetadata metadata = null;

    try {
        ApplicationAdminClient client = new ApplicationAdminClient(cookie,
                backendServerURL, configContext, request.getLocale());
        metadata = client.getAppData(appName);
    } catch (Exception e) {
        response.setStatus(500);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
    }

    boolean foundDataServices = false;
    boolean foundOtherServices = false;

%>


<fmt:bundle basename="org.wso2.carbon.application.mgt.ui.i18n.Resources">
    <carbon:breadcrumb label="carbonapps.application.dashboard"
                       resourceBundle="org.wso2.carbon.application.mgt.ui.i18n.Resources"
                       topPage="false" request="<%=request%>"/>

<script type="text/javascript">

//    function deleteArtifact(artifactName, artifactType, action) {
        <%--CARBON.showConfirmationDialog("<fmt:message key="confirm.delete.artifact"/>" , function(){--%>
//            document.appInfoForm.action = action + "?artifactName="
                    <%--+ artifactName + "&artifactType=" + artifactType + "&appName=<%= appName%>";--%>
//            document.appInfoForm.submit();
//        });
//    }

//    function deleteModule(moduleName, moduleVersion) {
        <%--CARBON.showConfirmationDialog("<fmt:message key="confirm.delete.artifact"/>" , function(){--%>
//            document.appInfoForm.action = "delete_artifact.jsp?artifactName="
                    <%--+ moduleName + "&moduleVersion=" + moduleVersion + "&appName=<%= appName%>";--%>
//            document.appInfoForm.submit();
//        });
//    }

</script>

    <div id="middle">
        <h2><fmt:message key="carbonapps.application.dashboard"/> : <%= appName%></h2>

        <div id="workArea">
            <form action="" name="appInfoForm" method="post">
                <%
                    if (metadata != null) {
                        ServiceGroupMetadata[] serviceGroups = metadata.getServiceGroups();
                        if (serviceGroups != null && serviceGroups.length > 0) {
                            for (ServiceGroupMetadata serviceGroup : serviceGroups) {
                                if ("service/dataservice".equals(serviceGroup.getSgType())) {
                                    foundDataServices = true;
                                } else {
                                    foundOtherServices = true;
                                }
                            }
                            if (foundOtherServices) {

                %>

                <table class="styledLeft" id="servicesTable" width="60%">
                    <thead>
                    <tr>
                        <th width="50%"><img src="images/service.gif" alt="" style="vertical-align:middle;">&nbsp;<fmt:message key="carbonapps.service.groups"/></th>
                        <th><fmt:message key="carbonapps.services"/></th>
                        <%--<th><fmt:message key="carbonapps.actions"/></th>--%>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        for (ServiceGroupMetadata serviceGroup : serviceGroups) {
                            if (!"service/dataservice".equals(serviceGroup.getSgType())) {
                    %>
                    <tr>
                        <td rowspan="<%= serviceGroup.getServices().length%>">
                            <a href="../service-mgt/list_service_group.jsp?serviceGroupName=<%= serviceGroup.getSgName()%>"><%= serviceGroup.getSgName()%></a>
                        </td>
                        <%
                            int serviceCount = 0;
                            for (String service : serviceGroup.getServices()) {
                                if (serviceCount != 0) {
                        %>
                        <tr>
                        <%
                            }
                        %>
                            <td><a href="../service-mgt/service_info.jsp?serviceName=<%= service%>"><%= service%></a></td>
                        <% if (serviceCount != 0) {%>
                        </tr>
                    <%
                                    }
                                    serviceCount++;
                                }
                            }
                        }
                    %>
                    </tbody>
                </table>

                <%
                    }
                    if (foundDataServices) { %>
                <p>&nbsp;&nbsp;</p>
                <table class="styledLeft" id="dataservicesTable" width="60%">
                    <thead>
                    <tr>
                        <th width="50%"><img src="../data_service/images/type.gif" alt="" style="vertical-align:middle;">&nbsp;<fmt:message key="carbonapps.ds.service.groups"/></th>
                        <th><fmt:message key="carbonapps.ds.services"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        for (ServiceGroupMetadata serviceGroup : serviceGroups) {
                            if ("service/dataservice".equals(serviceGroup.getSgType())) {
                    %>
                    <tr>
                        <td rowspan="<%= serviceGroup.getServices().length%>">
                            <a href="../service-mgt/list_service_group.jsp?serviceGroupName=<%= serviceGroup.getSgName()%>"><%= serviceGroup.getSgName()%></a>
                        </td>
                        <%
                                int serviceCount = 0;
                                for (String service : serviceGroup.getServices()) {
                                    if (serviceCount != 0) {
                        %>
                        <tr>
                        <%
                                    }
                        %>
                            <td><a href="../service-mgt/service_info.jsp?serviceName=<%= service%>"><%= service%></a></td>
                        <%          if (serviceCount != 0) {%>
                        </tr>
                    <%
                                    }
                                    serviceCount++;
                                }
                            }
                        }
                    %>
                    </tbody>
                </table>
                <%
                            }
                        }
                    String[] registryFilters = metadata.getRegistryFilters();
                    if (registryFilters != null && registryFilters.length > 0) {
                %>
                <p>&nbsp;&nbsp;</p>
                <table class="styledLeft" id="RegistryFiltersTable" width="40%">
                    <thead>
                    <tr>
                        <th><img src="images/filter.gif" alt="" style="vertical-align:middle;">&nbsp;<fmt:message key="carbonapps.registry.filters"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        for (String filter : registryFilters) {
                    %>
                    <tr>
                        <td><%= filter%></td>
                    </tr>
                    <%
                        }
                    %>
                    </tbody>
                </table>
                <%
                        }
                    }

                    if (CarbonUIUtil.isContextRegistered(config, "/synapse-apps/")) {
                        String synapseAppPage = "../synapse-apps/index.jsp?appName=" + appName;
                %>
                <jsp:include page="<%= synapseAppPage%>"/>
                <%
                    }

                    if (CarbonUIUtil.isContextRegistered(config, "/bpel-apps/")) {
                        String bpelAppPage = "../bpel-apps/index.jsp?appName=" + appName;
                %>
                <jsp:include page="<%= bpelAppPage%>"/>
                <%
                    }
                %>
            </form>
        </div>
    </div>

</fmt:bundle>